LeetCode62 Unique Paths 寻找不同路径

问题描述:
A robot is located at the top-left corner of a m x n grid (marked ‘Start’ in the diagram below).

The robot can only move either down or right at any point in time. The robot is trying to reach the bottom-right corner of the grid (marked ‘Finish’ in the diagram below).
这里写图片描述
How many possible unique paths are there?

Above is a 7 x 3 grid. How many possible unique paths are there?

Note: m and n will be at most 100.

Example 1:

Input: m = 3, n = 2
Output: 3

Explanation:
From the top-left corner, there are a total of 3 ways to reach the bottom-right corner:
1. Right -> Right -> Down
2. Right -> Down -> Right
3. Down -> Right -> Right
Example 2:

Input: m = 7, n = 3
Output: 28

题源:here;完整实现:here
思路:
两种方案:1 暴力搜索;2 动态规划。
1 暴力搜索
我们通过递归的方式找出所有的路径,提交结果是运行超时,代码如下:

    void findPath(int m, int n, int currM, int currN, int &result){
        if (currM >= m-1 || currN >= n-1){
            result++; return;}

        findPath(m, n, currM + 1, currN, result);
        findPath(m, n, currM, currN + 1, result);}

    int uniquePaths(int m, int n) {
        int result = 0;
        findPath(m, n, 0, 0, result);
        return result;}

2 动态规划
设二维矩阵dp中每个元素存放当前位置的路径数量,则有如下转移条件:

if i == m || j == n: dp[i][j] = 1
else: dp[i][j] = dp[i-1][j]+dp[i][j-1]

代码如下:

    int uniquePaths2(int m, int n){
        vector<vector<int>> dp(m, vector<int>(n, 1));
        for (int i = 1; i < m; i++){
            for (int j = 1; j < n; j++){
                dp[i][j] = dp[i - 1][j] + dp[i][j - 1];}}

        return dp[m - 1][n - 1];}};

最后贴出运行结果纪念一下:
这里写图片描述

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值